import { EventEmitter, QueryList } from '@angular/core';
import { FormControlStatus, FormGroup } from '@angular/forms';
import { AnyObject } from '@ngify/types';
import { NzFormLayoutType } from 'ng-zorro-antd/form';
import { NzAlign, NzJustify, NzRowDirective } from 'ng-zorro-antd/grid';
import { FluentConfig } from '../../config';
import { FluentTemplateDirective } from '../../directives';
import { TemplateDirectiveContainer } from '../../interfaces';
import { AnySchema, FormGroupSchema } from '../../schemas';
import { SchemaKind } from '../../schemas/interfaces';
import * as i0 from "@angular/core";
export declare class FluentFormComponent<T extends AnyObject> implements FluentConfig, TemplateDirectiveContainer {
    private readonly destroy$;
    private readonly formUtil;
    private readonly modelUtil;
    private readonly schemaUtil;
    /**
     * 内部的不可变模型，主要有以下用途：
     * - 用来跟公开的模型值进行引用比较，判断变更是内部发出的还是外部传入的，如果引用一致则为内部变更
     */
    private internalModel;
    private _model;
    private _schema;
    protected readonly SchemaKind: typeof SchemaKind;
    protected get schemas(): AnySchema[];
    form: FormGroup;
    set schema(value: FormGroupSchema);
    get schema(): FormGroupSchema;
    set model(value: T);
    get model(): T;
    layout: NzFormLayoutType;
    colon: boolean;
    gutter: NzRowDirective['nzGutter'] | null;
    align: NzAlign | null;
    justify: NzJustify | null;
    formChange: EventEmitter<FormGroup>;
    modelChange: EventEmitter<T>;
    valueChanges: EventEmitter<T>;
    statusChanges: EventEmitter<FormControlStatus>;
    submit: EventEmitter<SubmitEvent>;
    templateDirectives: QueryList<FluentTemplateDirective>;
    constructor();
    private createForm;
    private updateForm;
    private onValueChanges;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentFormComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FluentFormComponent<any>, "fluent-form", never, { "schema": { "alias": "schema"; "required": false; }; "model": { "alias": "model"; "required": false; }; "layout": { "alias": "layout"; "required": false; }; "colon": { "alias": "colon"; "required": false; }; "gutter": { "alias": "gutter"; "required": false; }; "align": { "alias": "align"; "required": false; }; "justify": { "alias": "justify"; "required": false; }; }, { "formChange": "formChange"; "modelChange": "modelChange"; "valueChanges": "valueChanges"; "statusChanges": "statusChanges"; "submit": "submit"; }, ["templateDirectives"], never, true, never>;
}
