import { SafeAny } from '@ngify/types';
import { AnySchema, FormArraySchema, FormGroupSchema, SingleSchemaKey } from '../schemas';
import { UnstableBuilder } from './compose-builder';
import { KindOrKey } from './helper';
export declare function group(): UnstableBuilder<FormGroupSchema<number>, KindOrKey>;
export declare function group<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<FormGroupSchema<Key>, KindOrKey>;
export declare function array(): UnstableBuilder<FormArraySchema<number>, KindOrKey>;
export declare function array<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<FormArraySchema<Key>, KindOrKey>;
export declare function form(composeFn: FormComposeFn, config?: FormConfig): FormGroupSchema;
export declare function form(schemas: AnySchema[], config?: FormConfig): FormGroupSchema;
type FormComposeFn = () => SafeAny;
type FormConfig = Omit<FormGroupSchema, KindOrKey | 'label' | 'schemas'>;
export {};
